// BMP.cc
// extracts/inserts data from/into .bmp file
// Adapted by Josh Holtrop from the original access_bmp.c by gw
// Supports reading and creating 24-bit color BMP images

#include "BMP.h"
#include <stdio.h>
#include <iostream>
using namespace std;

BMP::BMP(const char * fileName)
{
    open(fileName);
}

BMP::BMP(const char * fileName, int width, int height, unsigned char * data)
{
    create(fileName, width, height, data);
}

BMP::~BMP()
{
    if (m_fp != NULL)
        close();
}

bool BMP::open(const char * fileName)
{
    m_fp = fopen(fileName, "r+");
    if (m_fp != NULL)
    {
		// read file header
		fread(&m_header, sizeof(m_header), 1, m_fp);
		if (m_header.id[0] != 'B' || m_header.id[1] != 'M')
		{
            cerr << fileName << " does not appear to be a BMP file." << endl;
			fclose(m_fp);
			m_fp = NULL;
		}
		// read image information
		fread(&m_info, sizeof(m_info), 1, m_fp);	
    }
    return (m_fp != NULL);
}

bool BMP::create(const char * fileName, int width, int height, unsigned char * data)
{
    m_fp = fopen(fileName, "w+");
    if (m_fp != NULL)
    {
        /* Initialize the header structure */
        m_header.id[0] = 'B';
        m_header.id[1] = 'M';
        int row_padding = (3 * width) & 0x3;
        if (row_padding)
            row_padding = 4 - row_padding;
        int row_bytes = (3 * width) + row_padding;
        m_header.file_size = sizeof(m_header) +
                           sizeof(m_info) +
                           row_bytes * height;
        m_header.reserved = 0;
        m_header.offset = sizeof(m_header) + sizeof(m_info);

        /* Initialize the information structure */
        m_info.header_size = 40;
        m_info.width = width;
        m_info.height = height;
        m_info.color_planes = 1;
        m_info.color_depth = 24;
        m_info.compression = 0;
        m_info.image_size = 0;
        m_info.xresolution = 2835;
        m_info.yresolution = 2835;
        m_info.num_colors = 0;
        m_info.num_important_colors = 0;

        /* write them to the file */
        fwrite(&m_header, sizeof(m_header), 1, m_fp);
        fwrite(&m_info, sizeof(m_info), 1, m_fp);

        unsigned int zero = 0;
        unsigned char * data_ptr = data + (3 * width) * (height - 1);
        for (int i = 0; i < height; i++)
        {
            fwrite(data_ptr, 3 * width, 1, m_fp);
            if (row_padding)
                fwrite(&zero, row_padding, 1, m_fp);
            data_ptr -= 3 * width;
        }
    }
    return (m_fp != NULL);
}

void BMP::read(unsigned char * buf)
{
    if (m_fp != NULL)
    {
        int row_data_bytes = 3 * m_info.width;
        int row_padding = row_data_bytes & 0x3;
        if (row_padding)
            row_padding = 4 - row_padding;
        fseek(m_fp,
              (m_header.offset != 0
                  ? m_header.offset
                  : sizeof(m_header) + sizeof(m_info)),
              SEEK_SET);
        unsigned char * data_ptr = buf + row_data_bytes * (m_info.height - 1);
        for (int i = 0; i < m_info.height; i++)
        {
            fread(data_ptr, row_data_bytes, 1, m_fp);
            if (row_padding)
                fseek(m_fp, row_padding, SEEK_CUR);
            data_ptr -= row_data_bytes;
        }
    }
}

void BMP::close()
{
    if (m_fp != NULL)
        fclose(m_fp);
    m_fp = NULL;
}
